# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, Dict, Optional

from getopenpay.models.business_type import BusinessType
from getopenpay.models.object_name import ObjectName
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr


class AccountExternal(BaseModel):
  """
    AccountExternal
    """
  id: StrictStr = Field(..., description='Unique identifier of the account.')
  object: Optional[ObjectName] = None
  created_at: datetime = Field(
    ..., description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  updated_at: datetime = Field(
    ..., description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  is_deleted: Optional[StrictBool] = Field(
    False, description='If true, indicates that this object has been deleted'
  )
  name: StrictStr = Field(..., description='The account’s name.')
  business_type: BusinessType = Field(...)
  country: StrictStr = Field(..., description='The account’s country.')
  created_by_id: StrictInt = Field(
    ..., description='Unique identifier of the user who created the account.'
  )
  branding_settings: Dict[
    str, Any] = Field(..., description='The branding settings associated with this account.')
  event_settings: Dict[
    str, Any] = Field(..., description='Event settings associated with this account.')
  dunning_settings: Dict[
    str, Any] = Field(..., description='The dunning settings associated with this account.')
  subscription_settings: Dict[
    str, Any] = Field(..., description='The subscription settings associated with this account.')
  __properties = [
    'id', 'object', 'created_at', 'updated_at', 'is_deleted', 'name', 'business_type', 'country',
    'created_by_id', 'branding_settings', 'event_settings', 'dunning_settings',
    'subscription_settings'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> AccountExternal:
    """Create an instance of AccountExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> AccountExternal:
    """Create an instance of AccountExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return AccountExternal.parse_obj(obj)

    _obj = AccountExternal.parse_obj(
      {
        'id': obj.get('id'),
        'object': obj.get('object'),
        'created_at': obj.get('created_at'),
        'updated_at': obj.get('updated_at'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'name': obj.get('name'),
        'business_type': obj.get('business_type'),
        'country': obj.get('country'),
        'created_by_id': obj.get('created_by_id'),
        'branding_settings': obj.get('branding_settings'),
        'event_settings': obj.get('event_settings'),
        'dunning_settings': obj.get('dunning_settings'),
        'subscription_settings': obj.get('subscription_settings')
      }
    )
    return _obj
