# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Optional

from getopenpay.models.object_name import ObjectName
from getopenpay.models.role_enum import RoleEnum
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr


class ApiTokenExternal(BaseModel):
  """
    ApiTokenExternal
    """
  id: StrictStr = Field(..., description='Unique identifier of the api token.')
  object: Optional[ObjectName] = None
  created_at: datetime = Field(
    ..., description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  updated_at: datetime = Field(
    ..., description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  is_deleted: Optional[StrictBool] = Field(
    False, description='If true, indicates that this object has been deleted'
  )
  secret_token: StrictStr = Field(
    ..., description='The secret token used for request authorization.'
  )
  publishable_token: StrictStr = Field(
    ..., description='The publishable token used for request authorization.'
  )
  user_id: StrictInt = Field(..., description='Unique identifier of the user.')
  role: RoleEnum = Field(...)
  description: Optional[StrictStr] = Field(...)
  is_protected: StrictBool = Field(..., description='Whether the token is protected from deletion.')
  __properties = [
    'id', 'object', 'created_at', 'updated_at', 'is_deleted', 'secret_token', 'publishable_token',
    'user_id', 'role', 'description', 'is_protected'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> ApiTokenExternal:
    """Create an instance of ApiTokenExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # set to None if description (nullable) is None
    # and __fields_set__ contains the field
    if self.description is None and 'description' in self.__fields_set__:
      _dict['description'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> ApiTokenExternal:
    """Create an instance of ApiTokenExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return ApiTokenExternal.parse_obj(obj)

    _obj = ApiTokenExternal.parse_obj(
      {
        'id': obj.get('id'),
        'object': obj.get('object'),
        'created_at': obj.get('created_at'),
        'updated_at': obj.get('updated_at'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'secret_token': obj.get('secret_token'),
        'publishable_token': obj.get('publishable_token'),
        'user_id': obj.get('user_id'),
        'role': obj.get('role'),
        'description': obj.get('description'),
        'is_protected': obj.get('is_protected')
      }
    )
    return _obj
