# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import List, Optional

from getopenpay.models.checkout_mode import CheckoutMode
from getopenpay.models.create_checkout_line_item import CreateCheckoutLineItem
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist


class CreateCheckoutSessionRequest(BaseModel):
  """
    CreateCheckoutSessionRequest
    """
  client_reference_id: Optional[StrictStr] = None
  coupon_id: Optional[StrictStr] = None
  currency: Optional[StrictStr] = None
  customer_id: Optional[StrictStr] = None
  customer_email: Optional[StrictStr] = None
  line_items: Optional[conlist(CreateCheckoutLineItem)] = None
  mode: CheckoutMode = Field(...)
  return_url: Optional[StrictStr] = None
  success_url: Optional[StrictStr] = None
  trial_end: Optional[datetime] = None
  trial_period_days: Optional[StrictInt] = None
  trial_from_price: Optional[StrictBool] = None
  __properties = [
    'client_reference_id', 'coupon_id', 'currency', 'customer_id', 'customer_email', 'line_items',
    'mode', 'return_url', 'success_url', 'trial_end', 'trial_period_days', 'trial_from_price'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> CreateCheckoutSessionRequest:
    """Create an instance of CreateCheckoutSessionRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # override the default output from pydantic by calling `to_dict()` of each item in line_items (list)
    _items = []
    if self.line_items:
      for _item in self.line_items:
        if _item:
          _items.append(_item.to_dict())
      _dict['line_items'] = _items
    # set to None if client_reference_id (nullable) is None
    # and __fields_set__ contains the field
    if self.client_reference_id is None and 'client_reference_id' in self.__fields_set__:
      _dict['client_reference_id'] = None

    # set to None if coupon_id (nullable) is None
    # and __fields_set__ contains the field
    if self.coupon_id is None and 'coupon_id' in self.__fields_set__:
      _dict['coupon_id'] = None

    # set to None if customer_id (nullable) is None
    # and __fields_set__ contains the field
    if self.customer_id is None and 'customer_id' in self.__fields_set__:
      _dict['customer_id'] = None

    # set to None if customer_email (nullable) is None
    # and __fields_set__ contains the field
    if self.customer_email is None and 'customer_email' in self.__fields_set__:
      _dict['customer_email'] = None

    # set to None if return_url (nullable) is None
    # and __fields_set__ contains the field
    if self.return_url is None and 'return_url' in self.__fields_set__:
      _dict['return_url'] = None

    # set to None if success_url (nullable) is None
    # and __fields_set__ contains the field
    if self.success_url is None and 'success_url' in self.__fields_set__:
      _dict['success_url'] = None

    # set to None if trial_end (nullable) is None
    # and __fields_set__ contains the field
    if self.trial_end is None and 'trial_end' in self.__fields_set__:
      _dict['trial_end'] = None

    # set to None if trial_period_days (nullable) is None
    # and __fields_set__ contains the field
    if self.trial_period_days is None and 'trial_period_days' in self.__fields_set__:
      _dict['trial_period_days'] = None

    # set to None if trial_from_price (nullable) is None
    # and __fields_set__ contains the field
    if self.trial_from_price is None and 'trial_from_price' in self.__fields_set__:
      _dict['trial_from_price'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> CreateCheckoutSessionRequest:
    """Create an instance of CreateCheckoutSessionRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return CreateCheckoutSessionRequest.parse_obj(obj)

    _obj = CreateCheckoutSessionRequest.parse_obj(
      {
        'client_reference_id': obj.get('client_reference_id'),
        'coupon_id': obj.get('coupon_id'),
        'currency': obj.get('currency'),
        'customer_id': obj.get('customer_id'),
        'customer_email': obj.get('customer_email'),
        'line_items':
          [CreateCheckoutLineItem.from_dict(_item) for _item in obj.get('line_items')]
          if obj.get('line_items') is not None else None,
        'mode': obj.get('mode'),
        'return_url': obj.get('return_url'),
        'success_url': obj.get('success_url'),
        'trial_end': obj.get('trial_end'),
        'trial_period_days': obj.get('trial_period_days'),
        'trial_from_price': obj.get('trial_from_price')
      }
    )
    return _obj
