# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import List, Optional

from getopenpay.models.collection_method_enum import CollectionMethodEnum
from getopenpay.models.selected_price_quantity import SelectedPriceQuantity
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist


class CreateSubscriptionRequest(BaseModel):
  """
    CreateSubscriptionRequest
    """
  customer_id: StrictStr = Field(..., description='Unique Identifier of the customer.')
  payment_method_id: Optional[StrictStr] = None
  selected_product_price_quantity: conlist(SelectedPriceQuantity) = Field(...)
  total_amount_atom: StrictInt = Field(
    ...,
    description='Total amount of this subscription. It is in atomic units (in USD this is cents).'
  )
  cancel_at_end: Optional[StrictBool] = Field(
    False,
    description=
    'Boolean indicating whether this subscription should cancel at the end of the current period.'
  )
  description: Optional[StrictStr] = None
  trial_end: Optional[datetime] = None
  trial_period_days: Optional[StrictInt] = None
  trial_from_price: Optional[StrictBool] = None
  coupon_id: Optional[StrictStr] = None
  promotion_code_id: Optional[StrictStr] = None
  collection_method: Optional[CollectionMethodEnum] = None
  net_d: Optional[StrictInt] = None
  __properties = [
    'customer_id', 'payment_method_id', 'selected_product_price_quantity', 'total_amount_atom',
    'cancel_at_end', 'description', 'trial_end', 'trial_period_days', 'trial_from_price',
    'coupon_id', 'promotion_code_id', 'collection_method', 'net_d'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> CreateSubscriptionRequest:
    """Create an instance of CreateSubscriptionRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # override the default output from pydantic by calling `to_dict()` of each item in selected_product_price_quantity (list)
    _items = []
    if self.selected_product_price_quantity:
      for _item in self.selected_product_price_quantity:
        if _item:
          _items.append(_item.to_dict())
      _dict['selected_product_price_quantity'] = _items
    # set to None if payment_method_id (nullable) is None
    # and __fields_set__ contains the field
    if self.payment_method_id is None and 'payment_method_id' in self.__fields_set__:
      _dict['payment_method_id'] = None

    # set to None if description (nullable) is None
    # and __fields_set__ contains the field
    if self.description is None and 'description' in self.__fields_set__:
      _dict['description'] = None

    # set to None if trial_end (nullable) is None
    # and __fields_set__ contains the field
    if self.trial_end is None and 'trial_end' in self.__fields_set__:
      _dict['trial_end'] = None

    # set to None if trial_period_days (nullable) is None
    # and __fields_set__ contains the field
    if self.trial_period_days is None and 'trial_period_days' in self.__fields_set__:
      _dict['trial_period_days'] = None

    # set to None if trial_from_price (nullable) is None
    # and __fields_set__ contains the field
    if self.trial_from_price is None and 'trial_from_price' in self.__fields_set__:
      _dict['trial_from_price'] = None

    # set to None if coupon_id (nullable) is None
    # and __fields_set__ contains the field
    if self.coupon_id is None and 'coupon_id' in self.__fields_set__:
      _dict['coupon_id'] = None

    # set to None if promotion_code_id (nullable) is None
    # and __fields_set__ contains the field
    if self.promotion_code_id is None and 'promotion_code_id' in self.__fields_set__:
      _dict['promotion_code_id'] = None

    # set to None if net_d (nullable) is None
    # and __fields_set__ contains the field
    if self.net_d is None and 'net_d' in self.__fields_set__:
      _dict['net_d'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> CreateSubscriptionRequest:
    """Create an instance of CreateSubscriptionRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return CreateSubscriptionRequest.parse_obj(obj)

    _obj = CreateSubscriptionRequest.parse_obj(
      {
        'customer_id': obj.get('customer_id'),
        'payment_method_id': obj.get('payment_method_id'),
        'selected_product_price_quantity':
          [
            SelectedPriceQuantity.from_dict(_item)
            for _item in obj.get('selected_product_price_quantity')
          ] if obj.get('selected_product_price_quantity') is not None else None,
        'total_amount_atom': obj.get('total_amount_atom'),
        'cancel_at_end': obj.get('cancel_at_end')
                         if obj.get('cancel_at_end') is not None else False,
        'description': obj.get('description'),
        'trial_end': obj.get('trial_end'),
        'trial_period_days': obj.get('trial_period_days'),
        'trial_from_price': obj.get('trial_from_price'),
        'coupon_id': obj.get('coupon_id'),
        'promotion_code_id': obj.get('promotion_code_id'),
        'collection_method': obj.get('collection_method'),
        'net_d': obj.get('net_d')
      }
    )
    return _obj
