# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, Optional

from pydantic import BaseModel, Field, StrictStr


class CreateTaxIntegrationRequest(BaseModel):
  """
    CreateTaxIntegrationRequest
    """
  api_name: StrictStr = Field(...)
  api_keys: Optional[Any] = Field(
    ..., description='These keys will allow to authenticate API requests to the tax processor.'
  )
  accounting_tz: StrictStr = Field(
    ...,
    description=
    'The timezone name for the accounting timezone (see pytz.all_timezones for a full list)'
  )
  __properties = ['api_name', 'api_keys', 'accounting_tz']

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> CreateTaxIntegrationRequest:
    """Create an instance of CreateTaxIntegrationRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # set to None if api_keys (nullable) is None
    # and __fields_set__ contains the field
    if self.api_keys is None and 'api_keys' in self.__fields_set__:
      _dict['api_keys'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> CreateTaxIntegrationRequest:
    """Create an instance of CreateTaxIntegrationRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return CreateTaxIntegrationRequest.parse_obj(obj)

    _obj = CreateTaxIntegrationRequest.parse_obj(
      {
        'api_name': obj.get('api_name'),
        'accounting_tz': obj.get('accounting_tz')
      }
    )
    return _obj
