# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import List, Optional

from getopenpay.models.object_name import ObjectName
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist


class ProductFamilyExternal(BaseModel):
  """
    ProductFamilyExternal
    """
  id: StrictStr = Field(..., description='Unique identifier of the product family.')
  object: Optional[ObjectName] = None
  created_at: datetime = Field(
    ..., description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  updated_at: datetime = Field(
    ..., description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  is_deleted: Optional[StrictBool] = Field(
    False, description='If true, indicates that this object has been deleted'
  )
  name: StrictStr = Field(..., description='Name of the product family.')
  description: Optional[StrictStr] = Field(...)
  products: conlist(StrictStr) = Field(...)
  hierarchy: Optional[StrictStr] = Field(
    '{}', description='A JSON object representing the hierarchy within the family.'
  )
  __properties = [
    'id', 'object', 'created_at', 'updated_at', 'is_deleted', 'name', 'description', 'products',
    'hierarchy'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> ProductFamilyExternal:
    """Create an instance of ProductFamilyExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # set to None if description (nullable) is None
    # and __fields_set__ contains the field
    if self.description is None and 'description' in self.__fields_set__:
      _dict['description'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> ProductFamilyExternal:
    """Create an instance of ProductFamilyExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return ProductFamilyExternal.parse_obj(obj)

    _obj = ProductFamilyExternal.parse_obj(
      {
        'id': obj.get('id'),
        'object': obj.get('object'),
        'created_at': obj.get('created_at'),
        'updated_at': obj.get('updated_at'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'name': obj.get('name'),
        'description': obj.get('description'),
        'products': obj.get('products'),
        'hierarchy': obj.get('hierarchy') if obj.get('hierarchy') is not None else '{}'
      }
    )
    return _obj
